#include "DisPdu203.h"
#include <conio.h>

cDisPduType::cDisPduType(void)
{
   for (int i=0; i<256; i++) {
      pdu[i] = (uint8) i;
   }
}


#ifdef _WIN32

TEntityID        cDisPdu::CmsEntID(const DIS203_ENTITY_ID_RECORD & id)
{
   //return TEntityID(id.simulation_address.site_id, id.simulation_address.application_id, id.entity_id);
	char *tmp = (char *)&id;
	char tmpID[2], tmpAPP[2], tmpE[2];
    tmpID[0] = tmp[1];
	tmpID[1] = tmp[0];
    uint16 * Uid = (uint16 *) tmpID; 
	tmpAPP[0] = tmp[3];
	tmpAPP[1] = tmp[2];
    uint16 * Uapp = (uint16 *) tmpAPP;
	tmpE[0] = tmp[5];
	tmpE[1] = tmp[4];
    uint16 * Ue = (uint16 *) tmpE; 
	//return TEntityID(id.simulation_address.site_id, id.simulation_address.application_id, id.entity_id);
	return TEntityID(*Uid, *Uapp, *Ue);
}

TEntityType      cDisPdu::CmsEntType(const DIS203_ENTITY_TYPE_RECORD & type)
{
	char *tmp = (char *)&type;
	char t_country[2], t_kind[1], t_do[1], t_cat[1], t_sucat[1], t_spec[1], t_ex[1];
//	uint8* kind = (uint8 *) tmp[0];
	t_kind[0] = tmp[0];
	uint8 * kind = (uint8 *)t_kind;
	t_do[0] = tmp[1];
	uint8 * domain = (uint8 *)t_do;
//	uint8 * domain = (uint8 *)tmp[1];
	t_country[0] = tmp[3];
	t_country[1] = tmp[2];
	uint16 * country = (uint16 *)t_country;
	t_cat[0] = tmp[4];
	uint8 * category = (uint8 *)t_cat;
	//uint8 * category = (uint8 *) tmp[4];
	t_sucat[0] = tmp[5];
	uint8 * subcategory = (uint8 *)t_sucat;
//	uint8 * subcategory = (uint8 *) tmp[5];
	t_spec[0] = tmp[6];
	uint8 * specific = (uint8 *)t_spec;
//	uint8 * specific = (uint8 *) tmp[6];
	t_ex[0] = tmp[7];
	uint8 * extra = (uint8 *)t_ex;
//	uint8 * extra = (uint8 *) tmp[7];
	return TEntityType(*kind,*domain, *country, *category, *subcategory, *specific, *extra);
//	return TEntityType((unsigned char)kind,(unsigned char) domain, (unsigned short)country, (unsigned char)category, (unsigned char)subcategory,(unsigned char) specific, (unsigned char)extra);
	// return TEntityType(type.kind, type.domain, type.country, type.category,
  //                    type.subcategory, type.specific, type.extra);
};

TLocation          cDisPdu::CmsVehLoc(const DIS203_WORLD_COORDINATES_RECORD & loc)
{   char *tmp = (char*) &loc;
	char tmpxf[8], tmpyf[8], tmpzf[8] ;
	double *x = (double*)&tmpxf;
	double *y = (double*)&tmpyf;
	double *z = (double*)&tmpzf;
    for(int i=0;i<8;i++) { tmpxf[i]=tmp[7-i]; tmpyf[i]=tmp[15-i]; tmpzf[i]=tmp[23-i] ; }
    return TLocation(*x,*y,*z);
  //return TLocation(loc.x, loc.y, loc.z);
};

TEntCoord        cDisPdu::CmsEntLoc(const DIS203_ENTITY_COORDINATE_VECTOR_RECORD & loc)
{   char *tmp = (char*) &loc;
	char tmpxf[4], tmpyf[4], tmpzf[4] ;
	float *x = (float*)&tmpxf;
	float *y = (float*)&tmpyf;
	float *z = (float*)&tmpzf;
    for(int i=0;i<4;i++) { tmpxf[i]=tmp[3-i]; tmpyf[i]=tmp[7-i]; tmpzf[i]=tmp[11-i] ; }
	return TEntCoord(*x,*y,*z);
   //return TEntCoord(loc.x, loc.y, loc.z);
};

TVelocity         cDisPdu::CmsVehVel(const DIS203_LINEAR_VELOCITY_VECTOR_RECORD & vel)
{
    char *tmp = (char*) &vel;
	char tmpxf[4], tmpyf[4], tmpzf[4] ;
	float *x = (float*)&tmpxf;
	float *y = (float*)&tmpyf;
	float *z = (float*)&tmpzf;
    for(int i=0;i<4;i++) { tmpxf[i]=tmp[3-i]; tmpyf[i]=tmp[7-i]; tmpzf[i]=tmp[11-i] ; }
    return   TVelocity(*x,*y,*z);
	//return	TVelocity(vel.x, vel.y, vel.z);
  
};

TOrient       cDisPdu::CmsVehOrient(const DIS203_EULER_ANGLES_RECORD & orient)
{   char *tmp = (char*) &orient;
	char tmpxf[4], tmpyf[4], tmpzf[4] ;
	float *x = (float*)&tmpxf;
	float *y = (float*)&tmpyf;
	float *z = (float*)&tmpzf;
    for(int i=0;i<4;i++) { tmpxf[i]=tmp[3-i]; tmpyf[i]=tmp[7-i]; tmpzf[i]=tmp[11-i] ; }
    return   TOrient(*x,*y,*z);
   //return TOrient(orient.psi, orient.theta, orient.phi);
};

TAccel        cDisPdu::CmsVehAccel(const DIS203_LINEAR_ACCELERATION_VECTOR_RECORD & accel)
{   char *tmp = (char*) &accel;
	char tmpxf[4], tmpyf[4], tmpzf[4] ;
	float *x = (float*)&tmpxf;
	float *y = (float*)&tmpyf;
	float *z = (float*)&tmpzf;
    for(int i=0;i<4;i++) { tmpxf[i]=tmp[3-i]; tmpyf[i]=tmp[7-i]; tmpzf[i]=tmp[11-i] ; }
    return   TAccel(*x,*y,*z);
   //return TAccel(accel.x, accel.y, accel.z);
}

TAngVel       cDisPdu::CmsVehAngVel(const DIS203_ANGULAR_VELOCITY_VECTOR_RECORD & angVel)
{   char *tmp = (char*) &angVel;
	char tmpxf[4], tmpyf[4], tmpzf[4] ;
	float *x = (float*)&tmpxf;
	float *y = (float*)&tmpyf;
	float *z = (float*)&tmpzf;
    for(int i=0;i<4;i++) { tmpxf[i]=tmp[3-i]; tmpyf[i]=tmp[7-i]; tmpzf[i]=tmp[11-i] ; }
    return TAngVel(*x, *y, *z);
	
   //return TAngVel(angVel.rate_about_x_axis, angVel.rate_about_y_axis, angVel.rate_about_z_axis);
}

#endif

int      cDisPduTranslator::ReceivePdu(void * buf, TTimeSim timeDelta )
{
         // VerifyPdu checks exercise and protocol version, not addressee
   if ( VerifyPdu(buf) ) {
      int   pduType = GetPduType( buf );
      int test;   
	  if (pduType == (int)gPduType.pdu[epduTypeEntityState]) {
               if ( gfNetif )
                  cout << "ES pdu " << endl;
			   
		        test = RecvESPdu(buf, timeDelta);
				return test;
	 }
      

        else if (pduType == (int)gPduType.pdu[epduTypeDetonation]) {
               if ( gfNetif )
                  cout << "Det pdu " << endl;
			    // to identify detonation
              test =  RecvDetonPdu(buf, timeDelta);
			  return test;
	 }

         else if (pduType == (int)gPduType.pdu[epduTypeCpMinefield]) {
               if ( gfNetif )
                  cout << "CP minefield pdu " << endl;
           //    if ( fpCpMgr )
           //       fpCpMgr->RecvCpMfPdu(buf, timeDelta);
		    test = RecvCpMfPdu(buf, timeDelta);
			return test;
	 }


         else if (pduType == (int)gPduType.pdu[epduTypeCpMines]) {
               if ( gfNetif )
                  cout << "CP mines pdu " << endl;
              // if ( fpCpMgr )
              //    fpCpMgr->RecvCpMinesPdu(buf, timeDelta);
			 test = RecvCpMinesPdu(buf,timeDelta);
			 return test;
	 }

   }
   else if ( gfNetif )
      cout << "pdu type not verified, ignored" << endl;
   return (0); // no PDU received or PDU ignored

}

int   cDisPduTranslator::GetPduType( void* buf)
{   
   return ((DIS203_PDU_HEADER_RECORD*) buf)->pdu_type;
}

EBoolean   cDisPduTranslator::VerifyPdu( void* buf)
   // verify incoming DIS PDUs.  We check:
   //   protocol version
   //   pdu type (in acceptable range, no experimental PDUs in this check)
   //   exercise ID
{   
   DIS203_PDU_HEADER_RECORD* pPdu = (DIS203_PDU_HEADER_RECORD*)buf;
 /*  if ( (pPdu->protocol_version == DIS203_PROTOCOL_VERSION_2_0)     &&
        (pPdu->exercise_id      == gpNetMgr->GetExerciseId() ) )*/
      return true;
   //else
     // return false;
}


int   cDisPduTranslator::RecvESPdu(void* buf, TTimeSim timeDelta)
{
   //cVehicle*             pVeh;
   //cPriorityVehStateMsg* pPmsg;
   //cVehStateMsg*         pMsg;
   DIS203_ENTITY_STATE_PDU* pdu = (DIS203_ENTITY_STATE_PDU*)buf;
    DIS203_PDU_HEADER_RECORD * hh = (DIS203_PDU_HEADER_RECORD *)buf;   
#ifndef _WIN32
   if ( ! ProcessableEsPdu(buf) ) {
      return;
   }
   #endif

#ifdef _WIN32
   Vehicle1* pVehicle = new Vehicle1;
   pVehicle->mTime = GetCurSimTime() - timeDelta;
   pVehicle->mID = cDisPdu::CmsEntID(pdu->entity_id);
   pVehicle->mLinearVel = cDisPdu::CmsVehVel(pdu->entity_linear_velocity);
  /**/ pVehicle->mAngularVel = cDisPdu::CmsVehAngVel(pdu->dead_reckoning_parameters.entity_angular_velocity);
   pVehicle->mAccel = cDisPdu::CmsVehAccel(pdu->dead_reckoning_parameters.entity_linear_accel);
   pVehicle->mLoc = cDisPdu::CmsVehLoc(pdu->entity_location);
   pVehicle->mOrientation = cDisPdu::CmsVehOrient(pdu->entity_orientation); 
   pVehicle->mEtype = cDisPdu::CmsEntType(pdu->entity_type);

   cVehUpdtMessage* VUMsg = new cVehUpdtMessage;
   VUMsg->SetMsg(pVehicle);
   gVehUpdtMessageList->addMessage(VUMsg);
   return(1);
   //gVehUpdtMessageList.addMessage(VUMsg);
}
#endif

#ifdef _WIN32
int   cDisPduTranslator::RecvDetonPdu(void * buf, TTimeSim )
{
//   cout<< "detonation PDU received"<endl;
   DIS203_DETONATION_PDU* pdu = (DIS203_DETONATION_PDU*)buf;
 
   Detonation* pDetonation = new Detonation;
   pDetonation->mFiringEntity = cDisPdu::CmsEntID(pdu->firing_entity_id);
   pDetonation->mTargetEntity = cDisPdu::CmsEntID(pdu->target_entity_id);
 //  pDetonation->mEventID = 
   pDetonation->mDetLocation = cDisPdu::CmsVehLoc(pdu->location_in_world);
   pDetonation->mDetGeoLocation = cDisPdu::CmsEntLoc(pdu->location_in_entity_coordinates);
   cDetMessage* DMsg = new cDetMessage;
   DMsg->SetMsg(pDetonation);
   gDetMessageList->addMessage(DMsg);
   return (2);
}

int   cDisPduTranslator::RecvCpMinesPdu(void * buf, TTimeSim timeDelta)
{
   MineData* pPdu = (MineData*) buf;
   Mine* ourMine = new Mine;
 //  cout << "mines pdu, num mines = "<< pPdu->num_mines << endl;
  ourMine->mine_set_id = TEntityID(pPdu->mine_set_id.simulation_address.site_id, pPdu->mine_set_id.simulation_address.application_id, pPdu->mine_set_id.entity_id);
   ourMine->q_sequence = pPdu->q_sequence;
 //  ourMine->munition = TEntityType(pPdu->munition.kind, pPdu->munition.domain, pPdu->munition.country, pPdu->munition.category,
 //                     pPdu->munition.subcategory, pPdu->munition.specific, pPdu->munition.extra);
   ourMine->num_mines = pPdu->num_mines;
   ourMine->ref_location = TLocation(pPdu->ref_location.x, pPdu->ref_location.y, pPdu->ref_location.z);
   cMineMessage* MMsg = new cMineMessage;
   MMsg->SetMsg(ourMine);
   gMineMessageList->addMessage(MMsg);
   return (3);
 
}

int cDisPduTranslator::RecvCpMfPdu(void* buf, TTimeSim timeDelta)
{
MineFieldData* pPdu = (MineFieldData*) buf;
MineField* ourMineField = new MineField;
ourMineField->minefield_id = TEntityID(pPdu->minefield_id.simulation_address.site_id, pPdu->minefield_id.simulation_address.application_id, pPdu->minefield_id.entity_id);
ourMineField->q_sequence = pPdu->q_sequence;
ourMineField->appearance = pPdu->appearance;
ourMineField->num_vertices = pPdu->num_vertices;
ourMineField->force_id = pPdu->force_id;
// forming a message
cMineFieldMessage* MFMsg = new cMineFieldMessage;
MFMsg->SetMsg(ourMineField);
gMineFieldMessageList->addMessage(MFMsg);
return (4);
}
#endif


cDisPduTranslator::cDisPduTranslator( EQrpProtocol qrp, ECpProtocol cp, EBoolean bOrient,
                                      EBoolean bBurial, EBoolean bTemp)
{
	// Allocating memory for the Message Lists
	gVehUpdtMessageList = new cVehUpdtMessageList;
	gMineFieldMessageList = new cMineFieldMessageList;
	gMineMessageList = new cMineMessageList;
	gDetMessageList = new cDetMessageList;
	
   /*if ( qrp ==  eQrp1 )
      fpQrpMgr = new cQrpManager( qrp, this);
   / *else if(qrp == eQrp3)
      fpQrpMgr = new cQrpManager_REV(qrp,this);* /
   else
      fpQrpMgr = NULL;
      
   if ( (cp == eCp1) ||
        (cp == eCp1HeartBeat) )
      fpCpMgr = new cCpManager( cp, this, bOrient, bBurial, bTemp );
   else
      fpCpMgr = NULL;
*/
      
}

cVehUpdtMessageList* cDisPduTranslator::getVehList(void)
//cVehUpdtMessageList cDisPduTranslator::getVehList(void)
 {
	return(gVehUpdtMessageList);
 }


cDetMessageList* cDisPduTranslator::getDetList(void)
{
	return(gDetMessageList);
}

cMineMessageList* cDisPduTranslator::getMineList(void)
{
	return(gMineMessageList);
}

cMineFieldMessageList* cDisPduTranslator::getMineFieldList(void)
{
	return(gMineFieldMessageList);
};

