#ifndef SC98WIN_H
#define SC98WIN_H

#pragma warning (disable:4786)

#include "RMWin.h"
#include <map>

typedef unsigned short entityID; 
typedef std::map< entityID, LPDIRECT3DRMFRAME, std::less<entityID> > entity_frame_map;

class SC98Win : public RMWin
{
public:
	SC98Win();
	~SC98Win();
	BOOL CreateScene();
protected:
	void OnIdle( long );
	//{{AFX_MSG(SC98Win)
	afx_msg void OnRenderWireframe();
	afx_msg void OnRenderFlat();
	afx_msg void OnRenderGouraud();
	afx_msg void OnUpdateRenderFlat(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRenderGouraud(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRenderWireframe(CCmdUI* pCmdUI);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnParameters();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL CreateTerrain(int numFaces);
	double ScaleX(double);
	double ScaleY(double);
	double ScaleZ(double);

	LPDIRECT3DRMMESHBUILDER terrainMeshBuilder;
	LPDIRECT3DRMMESHBUILDER tankMeshBuilder;
	LPDIRECT3DRMMESHBUILDER planeMeshBuilder;

	LPDIRECT3DRMFRAME terrainFrame;
	LPDIRECT3DRMFRAME vehicleFrame;

	LPDIRECT3DRMANIMATIONSET  blastAnim;
	LPDIRECT3DRMFRAME blastFrame;

	entity_frame_map efMap;
};


#endif
