#ifndef SIM_H
#define SIM_H

#include "GlobalTypes.h"
#include "dis203_types.h"
#include "p_dis203.h"
#ifdef _WIN32
// defining own class "Vehicle"
class Vehicle1
{
	public:
	Vehicle1(){} // constuctor
	~Vehicle1(){} // Destructor
	TTimeSim mTime;
	TEntityID mID;
	TVelocity mLinearVel;
	TAngVel mAngularVel;
	TLocation mLoc;
	TOrient mOrientation;		
	TAccel mAccel;
	TEntityType mEtype;
};

//defining own class Detonation
class Detonation {
public:
   TEntityID      mFiringEntity;
   TEntityID      mTargetEntity;
   TEntityID      mEventId;
   TLocation      mDetLocation;
  // TEntityType    mDetonationType;
   TEntCoord      mDetGeoLocation;
      

   
   Detonation(){};
   ~Detonation(){};
};

struct TSequence {
   unsigned short quiescent : 1;
   unsigned short sequence  : 15;
};

class Mine {
public:
TEntityID mine_set_id;
TSequence q_sequence;
TEntityType munition;
TLocation ref_location;
unsigned short num_mines;
  
};

struct MineData {
	 DIS203_PDU_HEADER_RECORD    fHeader;
   DIS203_ENTITY_ID_RECORD     mine_set_id;
   TSequence                      q_sequence;
//   unsigned short                 quiescent : 1;
//   unsigned short                 sequence : 15;
   DIS203_ENTITY_TYPE_RECORD   munition;
   DIS203_FUZE_TYPE            fuze;
   unsigned short                 num_mines;
   DIS203_WORLD_COORDINATES_RECORD   ref_location;
   
//   TMineDataFlag                  data_flags;
//   unsigned int                   orientation_flag : 1;
//   unsigned int                   burial_depth_flag : 1;
//   unsigned int                   temperature_flag : 1;
//   unsigned int                   _unused_ : 29;

   DIS203_VECTOR_RECORD          locations[ 1 /* num_mines */ ];
   
         // optional
//   DIS203_EULER_ANGLES_RECORD  orientations[num_mines];
//   float                          burial_depths[num_mines];
//   float                          temperatures[num_mines];

};

struct MineFieldData {
   DIS203_PDU_HEADER_RECORD    fHeader;
   DIS203_ENTITY_ID_RECORD     minefield_id;
   TSequence                      q_sequence;
//   unsigned short                 quiescent : 1;
//   unsigned short                 sequence : 15;
   unsigned short                 appearance;
   unsigned char                  num_vertices;
   unsigned char                  force_id;   
  
//      present in PDU as sent, dynamically sized
   DIS203_WORLD_COORDINATES_RECORD        vertices[ 1 /* num_vertices */];        

};

class MineField {
public:
	TEntityID minefield_id;
	TSequence q_sequence;
	unsigned short appearance;
	unsigned char num_vertices;
	unsigned char force_id;
};

#endif

#endif